#!%PERL% -w 
# Copyright (c) vhffs project and its contributors
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without 
# modification, are permitted provided that the following conditions 
# are met:
#
# 1. Redistributions of source code must retain the above copyright 
#   notice, this list of conditions and the following disclaimer.
#2. Redistributions in binary form must reproduce the above copyright
#   notice, this list of conditions and the following disclaimer in 
#   the documentation and/or other materials provided with the 
#   distribution.
#3. Neither the name of vhffs nor the names of its contributors 
#   may be used to endorse or promote products derived from this 
#   software without specific prior written permission.
#
#THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
#"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
#LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
#FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE 
#COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, 
#INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, 
#BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; 
#LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER 
#CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT 
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN 
# ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
# POSSIBILITY OF SUCH DAMAGE.


use utf8;
use POSIX qw(locale_h);
use HTML::Template;
use locale;
use Locale::gettext;
use CGI;
use CGI::Session;
use strict;

use lib '%VHFFS_LIB_DIR%';
use Vhffs::User;
use Vhffs::Group;
use Vhffs::Main;
use Vhffs::Panel::Main;
use Vhffs::Panel::Menu;
use Vhffs::Constants;

my $panel = new Vhffs::Panel::Main();
exit 0 unless $panel;
my $session = $panel->get_session;
exit 0 unless $session;

my $vhffs = $panel->{'vhffs'};
my $cgi = $panel->{'cgi'};
my $templatedir = $panel->{templatedir};

my $username = $cgi->param('user');

if( $panel->{user}->is_admin != 1 )
{
	
	my $template = new HTML::Template( filename => $templatedir."/panel/misc/simplemsg.tmpl" );
	$template->param( MESSAGE =>  gettext( 'You\'re not an administrator' ) );
	$panel->build( $template );
}
else
{
	unless( defined $username )  {
		my $template = new HTML::Template( filename => $templatedir."/panel/admin/misc/su.tmpl" );
		$template->param( TITLE => gettext("Change user-id") );	
		$template->param( TEXT => gettext("Username") );
		$template->param( TEXT_SUBMIT => gettext("Su !") );
		$panel->build( $template );
	}
	else
	{
		my $message = '';

		my $user = Vhffs::User::get_by_username( $vhffs , $username );
		if( defined $user )
		{
			$session->clear('username');
			$session->clear('uid');
			$session->param('username', $user->get_username);
			$session->param('uid', $user->get_uid);
			$session->flush();

			$panel = new Vhffs::Panel::Main();
			$session = $panel->get_session;
			$message = gettext( sprintf( 'Su successful with name %s' , $user->get_username) );
		}
		else
		{
			$message = sprintf( gettext( 'User %s does not exist' ) , $username  );
		}

		my $template = new HTML::Template( filename => $templatedir."/panel/misc/simplemsg.tmpl" );
		$template->param( MESSAGE => $message );
		$panel->build( $template );
	}
}

$panel->display;
